using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using MySql.Data.MySqlClient;
using fatd_faturamento.ENTIDADE;
using fatd_faturamento.DAL.Conexao;

namespace fatd_faturamento.DAL.Persistencia
{
    public class dalGDTipo
    {

        string vFILTER = null;
        string vINNERJOIN = null;
        string vAND = null;
        string vORDERBY = null;

        #region Métodos

        public void Insert_Update(entidadeGDTipo objGDTipo)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();
                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                DataTable dt = Select(objGDTipo);
                if (dt.Rows.Count != 0)
                { Update(objGDTipo); }
                else
                { Insert(objGDTipo); }

            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Insert(entidadeGDTipo objGDTipo)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = "";
                    vFILTER = vFILTER + "       UNID_ID                   = ?UNID_ID , ";
                    vFILTER = vFILTER + "       CONS_ID                   = ?CONS_ID , ";
                    vFILTER = vFILTER + "       ZONA                      = ?ZONA , ";
                    vFILTER = vFILTER + "       LIVRO                     = ?LIVRO , ";
                    vFILTER = vFILTER + "       CONTA                     = ?CONTA , ";
                    vFILTER = vFILTER + "       PERFIL                    = ?PERFIL , ";
                    vFILTER = vFILTER + "       TIPO                      = ?TIPO , ";
                    vFILTER = vFILTER + "       DATA_CADASTRO             = ?DATA_CADASTRO";

                    vAND = "";

                    cmd = new MySqlCommand(this.QueryInsert);

                    cmd.Parameters.AddWithValue("?UNID_ID", objGDTipo.UNID_ID);
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDTipo.CONS_ID);
                    cmd.Parameters.AddWithValue("?ZONA", objGDTipo.ZONA);
                    cmd.Parameters.AddWithValue("?LIVRO", objGDTipo.LIVRO);
                    cmd.Parameters.AddWithValue("?CONTA", objGDTipo.CONTA);
                    cmd.Parameters.AddWithValue("?PERFIL", objGDTipo.PERFIL);
                    cmd.Parameters.AddWithValue("?TIPO", objGDTipo.TIPO);
                    cmd.Parameters.AddWithValue("?DATA_CADASTRO", objGDTipo.DATA_CADASTRO);

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Update(entidadeGDTipo objGDTipo)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {

                    vFILTER = "";
                    vFILTER = vFILTER + " PERFIL    = ?PERFIL , ";
                    vFILTER = vFILTER + " TIPO      = ?TIPO ";

                    vAND = "";
                    vAND = vAND + "AND UNID_ID = ?UNID_ID ";
                    vAND = vAND + "AND CONS_ID = ?CONS_ID ";
                    vAND = vAND + "AND ZONA = ?ZONA ";
                    vAND = vAND + "AND LIVRO = ?LIVRO ";
                    vAND = vAND + "AND CONTA = ?CONTA ";


                    cmd = new MySqlCommand(this.QueryUpdate);


                    cmd.Parameters.AddWithValue("?PERFIL", objGDTipo.PERFIL);
                    cmd.Parameters.AddWithValue("?TIPO", objGDTipo.TIPO);

                    cmd.Parameters.AddWithValue("?UNID_ID", objGDTipo.UNID_ID);
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDTipo.CONS_ID);
                    cmd.Parameters.AddWithValue("?ZONA", objGDTipo.ZONA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?LIVRO", objGDTipo.LIVRO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA", objGDTipo.CONTA.ToString().ToUpper());


                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public DataTable Select(entidadeGDTipo objGDTipo)
        {
            DataTable dt = null;
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = "";
                    vFILTER = vFILTER + "ID, ";
                    vFILTER = vFILTER + "ZONA, ";
                    vFILTER = vFILTER + "LIVRO, ";
                    vFILTER = vFILTER + "CONTA, ";
                    vFILTER = vFILTER + "CONS_ID, ";
                    vFILTER = vFILTER + "UNID_ID, ";
                    vFILTER = vFILTER + "DATA_CADASTRO, ";
                    vFILTER = vFILTER + "PERFIL, ";
                    vFILTER = vFILTER + "TIPO, ";
                    vFILTER = vFILTER + "ID_ANTIGO  ";

                    vINNERJOIN = " ";

                    vORDERBY = " ";

                    vAND = "";
                    vAND = vAND + "AND ZONA = ?ZONA ";
                    vAND = vAND + "AND LIVRO = ?LIVRO ";
                    vAND = vAND + "AND CONTA = ?CONTA ";
                    vAND = vAND + "AND CONS_ID = ?CONS_ID  ";
                    vAND = vAND + "AND UNID_ID = ?UNID_ID ";

                    cmd = new MySqlCommand(this.QuerySelect);

                    cmd.Parameters.AddWithValue("?ZONA", objGDTipo.ZONA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?LIVRO", objGDTipo.LIVRO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA", objGDTipo.CONTA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDTipo.CONS_ID);
                    cmd.Parameters.AddWithValue("?UNID_ID", objGDTipo.UNID_ID);

                    dt = objGerenciadorTransacao.GetDataTable(cmd);
                }

                return dt;
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Delete(entidadeGDTipo objGDTipo)
        {

            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vORDERBY = " ";


                    vAND = vAND + "AND UNID_ID = ?UNID_ID ";
                    vAND = vAND + "AND CONS_ID = ?CONS_ID ";
                    vAND = vAND + "AND ZONA = ?ZONA ";
                    vAND = vAND + "AND LIVRO = ?LIVRO ";
                    vAND = vAND + "AND CONTA = ?CONTA ";


                    cmd = new MySqlCommand(this.QueryDelete);


                    cmd.Parameters.AddWithValue("?UNID_ID", objGDTipo.UNID_ID);
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDTipo.CONS_ID);
                    cmd.Parameters.AddWithValue("?ZONA", objGDTipo.ZONA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?LIVRO", objGDTipo.LIVRO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA", objGDTipo.CONTA.ToString().ToUpper());


                    objGerenciadorTransacao.Execute(cmd);
                }

            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }




        #endregion

        #region " Comandos SQL "

        StringBuilder sb = new StringBuilder();


        protected string QueryInsert
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("INSERT INTO  ");
                this.sb.AppendLine("GD_TIPO SET  ");
                this.sb.AppendLine(vFILTER);

                return sb.ToString();
            }
        }

        protected string QueryUpdate
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("UPDATE  ");
                this.sb.AppendLine("GD_TIPO SET  ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);

                return sb.ToString();
            }
        }

        protected string QueryDelete
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("DELETE FROM GD_TIPO ");
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        protected string QuerySelect
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("SELECT ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("FROM ");
                this.sb.AppendLine("GD_TIPO  ");
                this.sb.AppendLine(vINNERJOIN);
                this.sb.AppendLine("WHERE 1 = 1  ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }


        #endregion


    }
}
